from osv import fields
from osv import osv
from tools import config


class purchase_order(osv.osv):
    _inherit = 'purchase.order'

    def sanity_check(self, cr, uid, context=None):
        self.sanity_check_fast(cr, uid, context)
        return 0

    def sanity_check_fast(self, cr, uid, context):
        ''' A set of fast sanity checks
        '''
        self.po_invoice_exception(cr,uid,context)
        self.po_picking_exception(cr,uid,context)
        return

    def po_invoice_exception(self,cr,uid,context):
        case_id = self.pool.get('crm.helpdesk').sanity_test_create_stub_case(cr,uid,context,
        "Found POs in a state of Invoice Exception",
        """ This is a stub to track incidents where POs are found with the status "Invoice Exception". 
        """,
        'po_invoice_exception')

        po_ids = self.search(cr,uid,[('state','=','except_invoice')])
        if not po_ids: return # okay, no problems

        problem_writeup = "The following POs have been marked as having an Invoice Exception:\n\n";
        for po in self.browse(cr,uid,po_ids):
            problem_writeup += "%i - %s - %s\n" % (po.id,po.name,po.partner_id.name)
        problem_writeup += "\n\n";

        # now that we've finished documenting the problem let's notify the 
        # appropriate users
        self.pool.get('crm.helpdesk').sanity_test_log(
                  cr, uid, context,
                  case_id,
                  problem_writeup
              )

        return


    def po_picking_exception(self,cr,uid,context):
        case_id = self.pool.get('crm.helpdesk').sanity_test_create_stub_case(cr,uid,context,
        "Found POs in a state of Shipping Exception",
        """ This is a stub to track incidents where POs are found with the status "Shipping Exception". 
        """,
        'po_picking_exception')

        po_ids = self.search(cr,uid,[('state','=','except_picking')])
        if not po_ids: return # okay, no problems

        problem_writeup = "The following POs have been marked as having an Shipping Exception:\n\n";
        for po in self.browse(cr,uid,po_ids):
            problem_writeup += "%i - %s - %s\n" % (po.id,po.name,po.partner_id.name)
        problem_writeup += "\n\n";

        # now that we've finished documenting the problem let's notify the 
        # appropriate users
        self.pool.get('crm.helpdesk').sanity_test_log(
                  cr, uid, context,
                  case_id,
                  problem_writeup
              )

        return

purchase_order()
